/**********************************************************************
*  2006 Microchip Technology Inc.
*
* SOFTWARE LICENSE AGREEMENT:
* Microchip Technology Inc. (Microchip) licenses this software to you
* solely for use with Microchip dsPIC digital signal controller
* products. The software is owned by Microchip and is protected under
* applicable copyright laws.  All rights reserved.
*
* SOFTWARE IS PROVIDED AS IS.  MICROCHIP EXPRESSLY DISCLAIMS ANY
* WARRANTY OF ANY KIND, WHETHER EXPRESS OR IMPLIED, INCLUDING BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
* PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IN NO EVENT SHALL MICROCHIP
* BE LIABLE FOR ANY INCIDENTAL, SPECIAL, INDIRECT OR CONSEQUENTIAL
* DAMAGES, LOST PROFITS OR LOST DATA, HARM TO YOUR EQUIPMENT, COST OF
* PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR SERVICES, ANY CLAIMS
* BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF),
* ANY CLAIMS FOR INDEMNITY OR CONTRIBUTION, OR OTHER SIMILAR COSTS.
*
**********************************************************************/

#include <p33fxxxx.h>
#include <limits.h>
#include <math.h>
#define STEPS 256
#define SCALE 100.0
#define tMax 4
#define tMin -4

void Example (void);

int mybuffer[STEPS];
long rangeMin, rangeMax;
long double t, interval;
int stepcount;
int Amp, Freq;

int main (void)
{
  while (1)
    {
      Example();
    }
}

void Example (void)
{
  rangeMax = tMax;
  rangeMin = tMin;
  interval = ((float)rangeMax-(float)rangeMin)/STEPS;
  t = rangeMin;

  for (stepcount = 0; stepcount < STEPS; stepcount++)
    {
      mybuffer [stepcount] =
        ((long double)Amp) * (sinl (((long double)Freq/SCALE) * t));
      t += interval;
    }
}
